import{s as ye,n as ve,o as we}from"../chunks/scheduler.37c15a92.js";import{S as $e,i as Te,g as o,s as a,r as p,A as xe,h as s,f as i,c as l,j as ce,u,x as r,k as ge,y as be,a as n,v as f,d as m,t as d,w as c}from"../chunks/index.7cb9c9b8.js";import{H as D,E as Le}from"../chunks/EditOnGithub.858acfec.js";function _e(ae){let h,O,G,z,g,S,y,le="This is a community-created glossary. Contributions are welcomed!",q,v,R,w,oe="<li><strong>Policy-based methods.</strong> The policy is usually trained with a neural network to select what action to take given a state. In this case it is the neural network which outputs the action that the agent should take instead of using a value function. Depending on the experience received by the environment, the neural network will be re-adjusted and will provide better actions.</li> <li><strong>Value-based methods.</strong> In this case, a value function is trained to output the value of a state or a state-action pair that will represent our policy. However, this value doesn’t define what action the agent should take. In contrast, we need to specify the behavior of the agent given the output of the value function. For example, we could decide to adopt a policy to take the action that always leads to the biggest reward (Greedy Policy). In summary, the policy is a Greedy Policy (or whatever decision the user takes) that uses the values of the value-function to decide the actions to take.</li>",j,$,F,T,se="<li><strong>The state-value function.</strong> For each state, the state-value function is the expected return if the agent starts in that state and follows the policy until the end.</li> <li><strong>The action-value function.</strong> In contrast to the state-value function, the action-value calculates for each state and action pair the expected return if the agent starts in that state, takes that action, and then follows the policy forever after.</li>",W,x,V,b,re="<li>Common strategy used in reinforcement learning that involves balancing exploration and exploitation.</li> <li>Chooses the action with the highest expected reward with a probability of 1-epsilon.</li> <li>Chooses a random action with a probability of epsilon.</li> <li>Epsilon is typically decreased over time to shift focus towards exploitation.</li>",B,L,J,_,he="<li>Involves always choosing the action that is expected to lead to the highest reward, based on the current knowledge of the environment. (Only exploitation)</li> <li>Always chooses the action with the highest expected reward.</li> <li>Does not include any exploration.</li> <li>Can be disadvantageous in environments with uncertainty or unknown optimal actions.</li>",K,C,N,M,pe="<li><strong>Off-policy algorithms:</strong> A different policy is used at training time and inference time</li> <li><strong>On-policy algorithms:</strong> The same policy is used during training and inference</li>",Q,k,X,H,ue="<li><p><strong>Monte Carlo (MC):</strong> Learning at the end of the episode. With Monte Carlo, we wait until the episode ends and then we update the value function (or policy function) from a complete episode.</p></li> <li><p><strong>Temporal Difference (TD):</strong> Learning at each step. With Temporal Difference Learning, we update the value function (or policy function) at each step without requiring a complete episode.</p></li>",Y,P,fe='If you want to improve the course, you can <a href="https://github.com/huggingface/deep-rl-class/pulls" rel="nofollow">open a Pull Request.</a>',Z,E,me="This glossary was made possible thanks to:",ee,A,de='<li><a href="https://github.com/ramon-rd" rel="nofollow">Ramón Rueda</a></li> <li><a href="https://github.com/hasarinduperera/" rel="nofollow">Hasarindu Perera</a></li> <li><a href="https://github.com/arkadyark/" rel="nofollow">Arkady Arkhangorodsky</a></li>',te,U,ie,I,ne;return g=new D({props:{title:"Glossary",local:"glossary",headingTag:"h1"}}),v=new D({props:{title:"Strategies to find the optimal policy",local:"strategies-to-find-the-optimal-policy",headingTag:"h3"}}),$=new D({props:{title:"Among the value-based methods, we can find two main strategies",local:"among-the-value-based-methods-we-can-find-two-main-strategies",headingTag:"h3"}}),x=new D({props:{title:"Epsilon-greedy strategy:",local:"epsilon-greedy-strategy",headingTag:"h3"}}),L=new D({props:{title:"Greedy strategy:",local:"greedy-strategy",headingTag:"h3"}}),C=new D({props:{title:"Off-policy vs on-policy algorithms",local:"off-policy-vs-on-policy-algorithms",headingTag:"h3"}}),k=new D({props:{title:"Monte Carlo and Temporal Difference learning strategies",local:"monte-carlo-and-temporal-difference-learning-strategies",headingTag:"h3"}}),U=new Le({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit2/glossary.mdx"}}),{c(){h=o("meta"),O=a(),G=o("p"),z=a(),p(g.$$.fragment),S=a(),y=o("p"),y.textContent=le,q=a(),p(v.$$.fragment),R=a(),w=o("ul"),w.innerHTML=oe,j=a(),p($.$$.fragment),F=a(),T=o("ul"),T.innerHTML=se,W=a(),p(x.$$.fragment),V=a(),b=o("ul"),b.innerHTML=re,B=a(),p(L.$$.fragment),J=a(),_=o("ul"),_.innerHTML=he,K=a(),p(C.$$.fragment),N=a(),M=o("ul"),M.innerHTML=pe,Q=a(),p(k.$$.fragment),X=a(),H=o("ul"),H.innerHTML=ue,Y=a(),P=o("p"),P.innerHTML=fe,Z=a(),E=o("p"),E.textContent=me,ee=a(),A=o("ul"),A.innerHTML=de,te=a(),p(U.$$.fragment),ie=a(),I=o("p"),this.h()},l(e){const t=xe("svelte-u9bgzb",document.head);h=s(t,"META",{name:!0,content:!0}),t.forEach(i),O=l(e),G=s(e,"P",{}),ce(G).forEach(i),z=l(e),u(g.$$.fragment,e),S=l(e),y=s(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-m5t86f"&&(y.textContent=le),q=l(e),u(v.$$.fragment,e),R=l(e),w=s(e,"UL",{"data-svelte-h":!0}),r(w)!=="svelte-4zruja"&&(w.innerHTML=oe),j=l(e),u($.$$.fragment,e),F=l(e),T=s(e,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-1wxmu8n"&&(T.innerHTML=se),W=l(e),u(x.$$.fragment,e),V=l(e),b=s(e,"UL",{"data-svelte-h":!0}),r(b)!=="svelte-1hskw15"&&(b.innerHTML=re),B=l(e),u(L.$$.fragment,e),J=l(e),_=s(e,"UL",{"data-svelte-h":!0}),r(_)!=="svelte-1o2on46"&&(_.innerHTML=he),K=l(e),u(C.$$.fragment,e),N=l(e),M=s(e,"UL",{"data-svelte-h":!0}),r(M)!=="svelte-y25p8z"&&(M.innerHTML=pe),Q=l(e),u(k.$$.fragment,e),X=l(e),H=s(e,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-192xlrh"&&(H.innerHTML=ue),Y=l(e),P=s(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1p0vyzq"&&(P.innerHTML=fe),Z=l(e),E=s(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1abantd"&&(E.textContent=me),ee=l(e),A=s(e,"UL",{"data-svelte-h":!0}),r(A)!=="svelte-pt1fzv"&&(A.innerHTML=de),te=l(e),u(U.$$.fragment,e),ie=l(e),I=s(e,"P",{}),ce(I).forEach(i),this.h()},h(){ge(h,"name","hf:doc:metadata"),ge(h,"content",Ce)},m(e,t){be(document.head,h),n(e,O,t),n(e,G,t),n(e,z,t),f(g,e,t),n(e,S,t),n(e,y,t),n(e,q,t),f(v,e,t),n(e,R,t),n(e,w,t),n(e,j,t),f($,e,t),n(e,F,t),n(e,T,t),n(e,W,t),f(x,e,t),n(e,V,t),n(e,b,t),n(e,B,t),f(L,e,t),n(e,J,t),n(e,_,t),n(e,K,t),f(C,e,t),n(e,N,t),n(e,M,t),n(e,Q,t),f(k,e,t),n(e,X,t),n(e,H,t),n(e,Y,t),n(e,P,t),n(e,Z,t),n(e,E,t),n(e,ee,t),n(e,A,t),n(e,te,t),f(U,e,t),n(e,ie,t),n(e,I,t),ne=!0},p:ve,i(e){ne||(m(g.$$.fragment,e),m(v.$$.fragment,e),m($.$$.fragment,e),m(x.$$.fragment,e),m(L.$$.fragment,e),m(C.$$.fragment,e),m(k.$$.fragment,e),m(U.$$.fragment,e),ne=!0)},o(e){d(g.$$.fragment,e),d(v.$$.fragment,e),d($.$$.fragment,e),d(x.$$.fragment,e),d(L.$$.fragment,e),d(C.$$.fragment,e),d(k.$$.fragment,e),d(U.$$.fragment,e),ne=!1},d(e){e&&(i(O),i(G),i(z),i(S),i(y),i(q),i(R),i(w),i(j),i(F),i(T),i(W),i(V),i(b),i(B),i(J),i(_),i(K),i(N),i(M),i(Q),i(X),i(H),i(Y),i(P),i(Z),i(E),i(ee),i(A),i(te),i(ie),i(I)),i(h),c(g,e),c(v,e),c($,e),c(x,e),c(L,e),c(C,e),c(k,e),c(U,e)}}}const Ce='{"title":"Glossary","local":"glossary","sections":[{"title":"Strategies to find the optimal policy","local":"strategies-to-find-the-optimal-policy","sections":[],"depth":3},{"title":"Among the value-based methods, we can find two main strategies","local":"among-the-value-based-methods-we-can-find-two-main-strategies","sections":[],"depth":3},{"title":"Epsilon-greedy strategy:","local":"epsilon-greedy-strategy","sections":[],"depth":3},{"title":"Greedy strategy:","local":"greedy-strategy","sections":[],"depth":3},{"title":"Off-policy vs on-policy algorithms","local":"off-policy-vs-on-policy-algorithms","sections":[],"depth":3},{"title":"Monte Carlo and Temporal Difference learning strategies","local":"monte-carlo-and-temporal-difference-learning-strategies","sections":[],"depth":3}],"depth":1}';function Me(ae){return we(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ee extends $e{constructor(h){super(),Te(this,h,Me,_e,ye,{})}}export{Ee as component};
